/* AbiSource
 * 
 * Copyright (C) 2002 Dom Lachowicz <cinamod@hotmail.com>
 * Copyright (C) 2005 Daniel d'Andrada T. de Carvalho
 * <daniel.carvalho@indt.org.br>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA.
 */


#ifndef _OO_STYLESCONTAINER_H_
#define _OO_STYLESCONTAINER_H_

// Abiword includes
#include <ut_hash.h>
#include <ut_vector.h>

class OO_StylesContainer
{
public:

    OO_StylesContainer() {}
    
    ~OO_StylesContainer() { 
        m_spanStylesHash.purgeData();
        m_blockAttsHash.purgeData();
        m_fontsHash.purgeData();
    }
    
    
    void addSpanStyle(UT_String &key);
    void addBlockStyle(UT_String & styleAtts, UT_String & styleProps);
    void addFont(UT_String & font);
    const int getSpanStyleNum(UT_String &key) const;
    const int getBlockStyleNum(UT_String & styleAtts, UT_String & styleProps) const;
    UT_GenericVector<int*> * enumerateSpanStyles() const;
    UT_String * pickBlockAtts(const UT_String *key);
    UT_GenericVector<const UT_String*> * getSpanStylesKeys() const;
    UT_GenericVector<const UT_String*> * getBlockStylesKeys() const;
    UT_GenericVector<const UT_String*> * getFontsKeys() const;
    
private:

    UT_GenericStringMap<int*> m_spanStylesHash;
    UT_GenericStringMap<UT_String*> m_blockAttsHash;
    UT_GenericStringMap<int*> m_fontsHash;
};



#endif //_OO_STYLESCONTAINER_H_
